
     /*      **
    * *       *
      *    ** *  HollaBack 0.1d : rue
      *   *  **
 *  *****  ** */



// moz1.3.1 doesn't do anything if the listener isn't set to capture
//   -- further, we can't remove a listener if it has inline-code.
function hbLoad() { HollaBack.initTrans(); }
function hbSetContext(evt) { HollaBack.setContext(evt); }
function hbLinkify(evt) { if (/*HollaBack.enabled &&*/ HollaBack.shouldStyle && evt.originalTarget.defaultView && !evt.originalTarget.defaultView._hbMain) HollaBack.linkify2(evt.originalTarget.defaultView); }


/*
** Main Routine
*/

var HollaBack = {
	
	// Called at script-end (below)
	load: function() {
		window.addEventListener("load",hbLoad,true);
		this.console = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
		this.passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].createInstance(Components.interfaces.nsIPasswordManager);
		this.passwordManagerInternal = Components.classes["@mozilla.org/passwordmanager;1"].createInstance(Components.interfaces.nsIPasswordManagerInternal);
		this.prefService = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService);
		this.prefBranch = "hollaback.";
		this.prefBranchSettings = "settings.";
		this.rootBranch = this.prefService.getBranch(null); // preferences root node
		this.Branch = this.prefService.getBranch(this.prefBranch);
		this.settingsBranch = this.prefService.getBranch(this.prefBranch+this.prefBranchSettings);
		this.tabBranch = this.prefService.getBranch("browser.tabs.");
		this.passManKey = "HollaBack.ext";
		this.numberRe = /^\s*(\(?\s*\d{3}\s*\)?)?(\s*[\.\-]?\s*)\d{3}(\s*[\.\-]?\s*)\d{4}\s*$/; // used by setContext() and linkify()  ->  (404) 665-3455
		
		// Preferrences Observer
		this.loadPrefObserver();
		
		// attach context-listener
		window.document.addEventListener("popupshown", hbSetContext, true);
		window._hbMain = true;
		window.addEventListener("load", hbLinkify, true);
	},
	
	// Called on first window-load
	initTrans: function() {
		window.removeEventListener("load",hbLoad,true); 
		this.labelBroadcaster  = document.getElementById('hollaback-label-broadcaster');
		this.normalBroadcaster = document.getElementById('hollaback-normal-broadcaster');
		this.setupBroadcaster  = document.getElementById('hollaback-setup-broadcaster');
		this.transBroadcaster  = document.getElementById('hollaback-trans-broadcaster');
		this.transClonePrincipal = document.getElementById("hollaback-trans-contextitem");
		this.contextPoint      = document.getElementById("hollaback-settings-contextitem");
		this.setupTrans();
	},
	setupTrans: function() {
		var prefixChildren = document.getElementsByAttribute("hb-trans-clone", "true"),   l =prefixChildren.length;
		while (l--) prefixChildren[l].parentNode.removeChild( prefixChildren[l] ); // XXX iterate backwards, to be live+dead-list compatible
		this.prefixArray = this.prefixString.split(",");
		this.trans = (this.shouldPrefix && this.prefixArray.length>0);
		if (this.trans) {
			for (var i=0; i<this.prefixArray.length; i++)  { 
				var clone = this.transClonePrincipal.cloneNode(true); 
				this.contextPoint.parentNode.insertBefore(clone,this.contextPoint);  // XXX *ding! everything fails if we set attribute-stuff, before the clone is appended
				clone.id="hb-clone-"+i; 
				clone.setAttribute("hb-trans-clone","true"); 
				clone.__hbtrans=this.prefixArray[i].split(" "); } // this.prefixArray[i]=this.prefixArray[i].split(" ");
		}
		this.updatedTrans = true; // for setContext, to discern if the label-attribute should be cycled -- we could cycle it here, but it's cleaner to keep that logic separate
	},
	
	// reveals context menu-items as needed
	setContext: function(evt) {
		if (evt.target.id != "contentAreaContextMenu") return;
	
		var target      = gContextMenu.target;
		var enabled     = this.enabled;
		var item        = this.item        ||(this.item=document.getElementById("hollaback-call-contextitem"));
		var activeLabel = this.activeLabel ||(this.activeLabel=item.getAttribute("activelabel"));
		var label       = this.labelBroadcaster;
		var rmv = "removeAttribute", set = "setAttribute", get = "getAttribute", has = "hasAttribute";
		
		// linkified context-click
		var link = target[has] && target[has]("hollaback-linkified");
		if (link)
			var selection = this.getLinkifiedText();
		// number-selection import
		else if (gContextMenu.isTextSelected) {
			selection = this.getSelection();
			var importable = (selection.length>0 && this.numberRe.test(selection));
			if (importable)
				selection = selection.replace(/(?:^\s*)|(?:\s*$)/g, "").replace(/^(\d{3}\))/, "($1"); // fixup partial beginning selections: 559) 3.. -> (559) 353-4423
		}

		// reveal relevant item(s)	
		var reveal = ( enabled && (link || importable));
		var setup  = (!enabled && (link || importable));
		var trans  = ( reveal && this.trans );
		if ( reveal )   { 
			if (this.updatedTrans && label[get]("hbselection") == selection) label[rmv]("hbselection"); // cycle the attribute, to trip the broadcaster  //selection += " ";
			label[set]("hbselection", selection);
			label[set]("label", activeLabel+selection+""); } // HollaBack  '(555) 421-6372'
	   ( reveal ) ? this.normalBroadcaster[rmv]('hidden') : this.normalBroadcaster[set]('hidden', 'true');
	   ( setup  ) ? this.setupBroadcaster [rmv]('hidden') : this.setupBroadcaster [set]('hidden', 'true'); // Disable if critical prefs aren't set (host, etc.)....and instead, direct the user to set them [Note: we shouldn't ever have 'link' without enabled, since hbLinkify() checks for it, too]
	   ( trans  ) ? this.transBroadcaster [rmv]('hidden') : this.transBroadcaster [set]('hidden', 'true');
		//this.lastset = ""+reveal+setup+trans;
		this.updatedTrans && (this.updatedTrans = null);
	},
	
	// reveals country-coded context menu-items, when setContext() propagates label-broadcasts
	snapTrans: function(evt, item) {
		//this.console.logStringMessage(item.id+" -> "+item.getAttribute("hbselection"));
		if (item.id == "hollaback-trans-contextitem") return; // ignore our clone-principal
		var activeLabel  = this.activeLabel;
		var transPrefix  = item.__hbtrans[0];  //this.prefixArray[transIndex][0]; //var transIndex = item.getAttribute("hbtransindex");
		var transCountry = item.__hbtrans[1]||""; //this.prefixArray[transIndex][1]||"";
		var selection    = item.getAttribute("hbselection");
		selection = selection.replace(/^(.*)?0/,"$1").replace(/^[^0-9\(]+/,"");
		item.__hbselection =      "+"+ transPrefix   +   selection;
		item.label = activeLabel +"+"+ transPrefix +" "+ selection+" " + "("+transCountry+")"; // HollaBack  +1 (555) 421-6372 (US)
	},
	
	callSelected: function(item) {
		var selection = item.__hbselection||item.getAttribute("hbselection");
		if (!selection || selection == "") { alert("Hollaback: unable to determine the number, yo."); return; }
		
		var url = this.selectionToLink(selection);
		//window._content.document.location.href = url;
		var newTab = window.getBrowser().addTab(url, null)
		var allowFocus = ! this.tabBranch.getBoolPref("loadInBackground");
		if (allowFocus) window.getBrowser().selectedTab = newTab;
		
		// https://10.10.0.4/servlet?uid=username&pass=password&from=6265551212&to-6265551244
		// host,url,username,password,   from DID (phone number),   to DID
	},
	
	selectionToLink: function(selection, settingsObj) {
		if (!this.enabled) return;
		var number = selection.replace(/[^0-9+]/g, ""); // now permitting the prefix '+'.  was-> /\D/g   -> .replace(/(^[^0-9+])|((.)[^0-9])/g, "$3")  -> parseInt(selection.replace(/[^0-9+]/g, ""));
		// Spaces are be translated to underscore (_) before saving as prefs
		paramObj = {settingsArray:this.settingsString.split(","), key:{"scheme":"callto","host":"127.0.0.0" /*,"path":"voip?"*/}, reserved:{"scheme":1/*,"host":1,"path":1,"":1*/}, replace:{"scheme":[/[^a-zA-Z]/gi,""],"host":[/[\/]$/,""],"path":[/^[\/]/,""]}, unkeyed:[], unkeyedString:"", unkeyedFirst:"", keyed:[], keyedString:""};
		var reservedRe = /(?:([\#\*]{0,2})\!|\!([\#\*]{0,2}))()()$/; // $1$2
		var privateRe =  /(?:([\#]?)\*|\*([\#]?))()()$/; // $1$2   -> /\*$/;
		var calleeRe =  /\#$/; //   -> /\#$/;
		for (var n in paramObj.settingsArray) {
			var id = paramObj.settingsArray[n],                     name = id;
			var isReserved = reservedRe.test(name); isReserved && ( name = name.replace(reservedRe,"$1$2"));
			var isPrivate = privateRe.test(name);   isPrivate  && ( name = name.replace(privateRe, "$1$2"));
			var isCallee = calleeRe.test(name);     isCallee   && ( name = name.replace(calleeRe,  ""));
			isPrivate && (isCallee=false); // we'll choose password-precedence
			var value = 
				isPrivate ? this.getPassword(name) // XXX hey, wait- isPrivate / isCallee are clearly exclusive of each other. hmm..
					: (isCallee ? number 
							: (this.settingsBranch.prefHasUserValue(name) ? this.settingsBranch.getCharPref(name) 
									: null) );
			if (value) {
				paramObj.key[name] = value;
				if (paramObj.replace[name]) paramObj.key[name] = paramObj.key[name].replace(paramObj.replace[name][0], paramObj.replace[name][1]);
				if (isReserved) (paramObj.keyed.length>0) ? (paramObj.keyed[paramObj.keyed.length-1]+=value) : (paramObj.unkeyedFirst+=value);//paramObj.unkeyed.push(value), paramObj.unkeyedString = paramObj.unkeyed.join("");
				else if (!paramObj.reserved[name]) paramObj.keyed.push(name+"="+paramObj.key[name]), paramObj.keyedString = paramObj.unkeyedFirst+paramObj.keyed.join("&"), paramObj.unkeyedFirst=""; }
		}
		
		var key = paramObj.key,   callString = paramObj.unkeyedFirst+paramObj.keyedString;
		var url = key["scheme"]+"://"+callString;
		//this.console.logStringMessage("HollaBack-url: "+url);
		return url;		
	},
	
	getPassword: function(name) {
		var host= {value:""};
		var username= {value:""};
		var password= {value:""};
		try{ this.passwordManagerInternal.findPasswordEntry(this.passManKey,name,"",host,username,password); }
		catch(e) {}
		return password.value;
	},

	getSelection: function() {
		var node = document.popupNode; // the element our context-popup is targeting (same as target)
		var selection = "";
		var nodeLocalName = node.localName.toLowerCase();
		if ((nodeLocalName == "textarea") ||
			(nodeLocalName == "input" && (node.type == "text" || node.type == "password")))
			selection = (node.value!="") ? node.value.substring(node.selectionStart, node.selectionEnd) : ""; // XXX caused fx1.0.6 to crash, when node.value was empty ("")
		else if (nodeLocalName == "option") {
			var parentSelect = node.parentNode;
			if (parentSelect.localName.toLowerCase() == "select") {
				if (parentSelect.multiple)
					for (var i = 0; i < parentSelect.options.length; i++)
						{ if (parentSelect.options[i].selected) selection += " " + parentSelect.options[i].value; }
				else selection = node.value;
			}
		}
		else if (nodeLocalName == "select")
			selection = node.options[node.selected].value;
		else {
			selection = document.commandDispatcher.focusedWindow.getSelection();
			// sorry- we'll have to require that the user actually right-click ON the selection 
			//  -- there doesn't seem any way to discover the selected-node that isn't ALWAYS .nodeName:#text (the underlying text)
			if (node.nodeName.toLowerCase() == "#text")  // text-nodes don't pass their newlines / breaks to getSelection()
				selection = selection.getRangeAt(0).cloneContents().firstChild.nodeValue;
		}
		return ""+selection; // triply-ensure coercion to string
	},
	
	getLinkifiedText: function() {
		var text = document.popupNode.getAttribute("hollaback-number") //.firstChild.data; // the element our context-popup is targeting (same as target)
		return text || "";
	},
	
	linkifyRe: /(?:\D|^)(?:((?:(?:\(\s*)?\d{3}(?:\s*\))?)(?:\s*[\.\-]?\s*)\d{3}(?:\s*[\.\-]?\s*)\d{4})|(\d{3}(?:\s*[\.\-]?\s*)\d{4}))(?:\D|$)/,
	
	// UNUSED: the binary range-search is much more efficient
	linkify: function(wnd, node, forceCheck) {
		if (node || (!wnd.hbLinkified || forceCheck)) {
			if (wnd) {
				wnd.hbLinkified = true;
				node = wnd.document.documentElement; }
			if (node && node.nodeType == Components.interfaces.nsIDOMNode.TEXT_NODE && node.data) { // 3
				var text = node.data, match, n = 0;
				while ((match = text.match(this.linkifyRe))) {
					//alert("text: "+text+"\nmatch: "+text.match(numberRe));
					var resultString = match[1] || match[2]; // [Note-to-self: the two extra are non-backref'd -rue]
					var matchText = node.splitText(text.indexOf(resultString));
					node = matchText.splitText(resultString.length);
					text = node.data;
					matchClone = matchText.cloneNode(true);
					if (this.shouldLinkify) {
						var linkNode = node.ownerDocument.createElement("a"); // [Done -rue: -> ] maybe we'll add a pref to "linkify" them again -- for now, it's nicer with just the context-menu
						linkNode.setAttribute("href", this.selectionToLink(resultString)); // return false to avoid activating the link-href
						//linkNode.setAttribute("onclick", "window.location.href='"+this.selectionToLink(match[1] || match[7])+"'; return false;"); // return false to avoid activating the link-href
					}
					else
						linkNode = node.ownerDocument.createElement("span");
					linkNode.setAttribute("hollaback-linkified", "true");
					linkNode.setAttribute("hollaback-number", resultString);
					linkNode.href = this.selectionToLink(resultString);
					linkNode.setAttribute("style", this.styleString); // "xbackground-image: url(b50p.png); xbackground-repeat: repeat; text-decoration: none; font-style: italic; -moz-opacity: 0.75; background-color: white; color: #1234AB; border-style: none; -moz-outline: #ABABFF dashed 1px !important");//"background-color: lightgray; color: darkgray;");
					linkNode.appendChild(matchClone);
					matchText.parentNode.replaceChild(linkNode, matchText);
				}
			}
			else if (node.nodeType == Components.interfaces.nsIDOMNode.ELEMENT_NODE //|| node.nodeType == Components.interfaces.nsIDOMNode.DOCUMENT_NODE
					&& node.childNodes && !(node.nodeName.toLowerCase() in {script:null,style:null,textarea:null,input:null}) //"script style textarea input".indexOf(node.nodeName.toLowerCase()) == -1
					&& !node.hasAttribute("hollaback-linkified"))
				for (var i = 0 ; i < node.childNodes.length ; i++)
					this.linkify(null, node.childNodes[i], forceCheck);

		}
		/*if (wnd)
			for (var i=0; i<wnd.frames.length; i++)
				this.linkify(wnd.frames[i]); // recurse*/
	},
	
	linkify2: function(wnd) {
		var activeLabel = document.getElementById("hollaback-call-contextitem").getAttribute("activelabel");
		var high = wnd.document.createRange();
				try {high.selectNodeContents(wnd.document.body);} catch(e) {this.console.logStringMessage(activeLabel+": Linkify failed: "+wnd.document.URL); return;}
		var searchRe = this.linkifyRe;
		var startIndex = 0, endIndex = high.commonAncestorContainer.childNodes.length;
		var rangeMatches = [];
		var externalCounter = {countMax:this.settingsBranch.getIntPref("style_searchMax"), matchMax:this.settingsBranch.getIntPref("style_matchMax"), count:0, matches:rangeMatches};
		if (high.toString().match(searchRe)) this.binaryRangeSearch(high, startIndex, endIndex, searchRe, rangeMatches, externalCounter);
		if (rangeMatches.length > 0) 
		for (var n in rangeMatches) if (rangeMatches[n].length == 1) this.replaceText(rangeMatches[n][0]);
		//this.console.logStringMessage(activeLabel+" count: "+externalCounter.count+" -> "+wnd.document.URL);
	},
	
	// Awesome
	binaryRangeSearch: function(high, startIndex, endIndex, searchRe, rangeMatches, externalCounter) {
		if (externalCounter.count++ > externalCounter.countMax || externalCounter.matches.length > externalCounter.matchMax) 
			return;
		var node = origNode = high.startContainer, origStartIndex = startIndex, origEndIndex = endIndex;
		if (endIndex - startIndex == 1 && node.childNodes.length > 0) {
			node = node.childNodes[endIndex-1]; while (node.childNodes.length == 1) {
				if (node.nodeName.toLowerCase() in {textarea:null,input:null,script:null,style:null}) return; // ignore these elements
				node = node.firstChild;
			}
			startIndex = 0, endIndex = node.childNodes.length;
			if (endIndex == 0) { rangeMatches.push([node]); return; } // this *must* come before we change high's indices (next)
					high.setStart(node, startIndex);
					high.setEnd(node, endIndex);
		}
		var midIndex = startIndex + Math.ceil((endIndex - startIndex) / 2);
		if (midIndex == endIndex || endIndex == 0) { rangeMatches.push([node]); return; }
				high.setEnd(node, midIndex);
		if (high.toString().match(searchRe)) { var deeper = true; this.binaryRangeSearch(high, startIndex, midIndex, searchRe, rangeMatches, externalCounter); }
		// split range
		var low = high;
				low.setEnd(node, endIndex); // *must* come first -- since we altered the end (above), we have to set it back.
				low.setStart(node, midIndex);
		if (low.toString().match(searchRe)) { deeper = true; this.binaryRangeSearch(low, midIndex, endIndex, searchRe, rangeMatches, externalCounter); }
		if (!deeper) rangeMatches.push([origNode,origStartIndex,origEndIndex]);
	},
	
	replaceText: function(node) {
		if (node && node.nodeType == Components.interfaces.nsIDOMNode.TEXT_NODE && node.data) { // 3
			var text = node.data, match, n = 0;
				//this.console.logStringMessage("text: "+text+"\n\n-> match: "+text.match(this.linkifyRe));
				//return;
			while ((match = text.match(this.linkifyRe))) {
				//alert("text: "+text+"\nmatch: "+text.match(numberRe));
				var resultString = match[1] || match[2]; // [Note-to-self: the two extra are non-backref'd -rue]
				var matchText = node.splitText(text.indexOf(resultString));
				node = matchText.splitText(resultString.length);
				text = node.data;
				matchClone = matchText.cloneNode(true);
				if (this.shouldLinkify) {
					var linkNode = node.ownerDocument.createElement("a"); // [Done -rue: -> ] maybe we'll add a pref to "linkify" them again -- for now, it's nicer with just the context-menu
					linkNode.setAttribute("href", this.selectionToLink(resultString)); // return false to avoid activating the link-href
					//linkNode.setAttribute("onclick", "window.location.href='"+this.selectionToLink(match[1] || match[7])+"'; return false;"); // return false to avoid activating the link-href
				}
				else
					linkNode = node.ownerDocument.createElement("span");
				linkNode.setAttribute("hollaback-linkified", "true");
				linkNode.setAttribute("hollaback-number", resultString);
				linkNode.href = this.selectionToLink(resultString);
				linkNode.setAttribute("style", this.styleString); // "xbackground-image: url(b50p.png); xbackground-repeat: repeat; text-decoration: none; font-style: italic; -moz-opacity: 0.75; background-color: white; color: #1234AB; border-style: none; -moz-outline: #ABABFF dashed 1px !important");//"background-color: lightgray; color: darkgray;");
				linkNode.appendChild(matchClone);
				matchText.parentNode.replaceChild(linkNode, matchText);
			}
		}
	},


/*
** Preferences observer interface -- implements nsIObserver
*/
	// Called by .load()
	loadPrefObserver: function() {
		this.windowInit = false;
		this.mainRe = 	/^(active|showtrans|trans|showstyle|style|linkify|searchMax|matchMax)$/;

		this.pbi = this.rootBranch.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
		this.pbi.addObserver(this.prefBranch+this.prefBranchSettings, this, true); // keep this last, in case we hit an error.
		this.observe(null, null, null);
	},
	
	// nsISupports interface implementation -- for weak-reference by pref-observer service
	QueryInterface: function(iid) {
		if (!iid.equals(Components.interfaces.nsISupports)
				&& !iid.equals(Components.interfaces.nsISupportsWeakReference)
				&& !iid.equals(Components.interfaces.nsIObserver)) {
			dump("Hollaback Window Pref-Observer factory object: QI unknown interface: " + iid + "\n");
			throw Components.results.NS_ERROR_NO_INTERFACE; }
		return this;
	},
	
	// removes the observer-object from service -- called when the window is no longer open
	removeObserver: function() {
		this.pbi.removeObserver(this.prefBranch+this.prefBranchSettings, this);
		delete this;
	},
	
	// observer-function
	/* subject: [wrapped nsISupports :: nsIPrefBranch], nsIPrefBranchInternal
	   topic: "changed"*/
	observe: function(subject, topic, prefName) {

		// if we don't have a valid window (closed)
		if ( !(typeof(document) == 'object' && document) ) {
			this.removeObserver(); // remove the observer..
			return; } // ..and don't continue
		
		prefName = (!prefName) ? "init" : prefName.match(new RegExp("^"+this.prefBranch+this.prefBranchSettings+"(.*)$"))[1];

		// on window-init, OR a status-critical pref change
		if (!this.windowInit || this.mainRe.test(prefName)) {
			this.enabled = this.settingsBranch.prefHasUserValue("active");
			
			if (this.enabled) {
				// XXX now we need a migration-path for the older "scheme,host,path" based layout; pending..
				var enforcedSettings = "scheme"; // "scheme,host"
				this.settingsString  = this.settingsBranch.getCharPref("active"); // array of pref-names holding window-sessions
				var  settingsJoiner  = (this.settingsString != "") ? "," : "";
				this.settingsString  = enforcedSettings + settingsJoiner + this.settingsString;
				this.shouldPrefix    =  this.settingsBranch.prefHasUserValue("showtrans") && this.settingsBranch.getBoolPref("showtrans"); // default:false
				this.defaultPrefix   = "1 US,44 Holland,36 Spain";
				this.prefixString    =  this.settingsBranch.prefHasUserValue("trans") ? this.settingsBranch.getCharPref("trans") : this.defaultPrefix;
			}
			if (!this.windowInit) {
				this.oldStyleRe  = /vodial/;
				this.defaultStyle= "text-decoration: none; font-style: italic; background-image: url(chrome://hollaback/content/w.75.png); background-repeat: repeat; color: #1234AB; border-style: none; -moz-outline: #ABABFF dashed 1px !important"; }
			this.shouldStyle     = !this.settingsBranch.prefHasUserValue("showstyle") || this.settingsBranch.getBoolPref("showstyle"); // default:true
			this.styleString     = this.settingsBranch.prefHasUserValue("style") ? this.settingsBranch.getCharPref("style").replace(this.oldStyleRe,"hollaback") : this.defaultStyle;
			this.shouldLinkify   = this.settingsBranch.prefHasUserValue("linkify") && this.settingsBranch.getBoolPref("linkify"); // default:false
			if (!this.windowInit) {
				if (!this.settingsBranch.prefHasUserValue("style_searchMax")) this.settingsBranch.setIntPref("style_searchMax", 300);
				if (!this.settingsBranch.prefHasUserValue("style_matchMax" )) this.settingsBranch.setIntPref("style_matchMax",   75); }
			this.searchMax = this.settingsBranch.prefHasUserValue("style_searchMax") ? this.settingsBranch.getIntPref("style_searchMax"):300; // default:300
			this.matchMax =  this.settingsBranch.prefHasUserValue("style_matchMax" ) ? this.settingsBranch.getIntPref("style_matchMax" ): 75; // default:75
			
			if (this.windowInit && prefName in {"showtrans":0,"trans":0}) { this.setupTrans(); }
		
			// window-init
			if (!this.windowInit) this.windowInit = true; } // flag as initialized
	}

	

};

HollaBack.load(); // fire -!