/*
** HollaBack 0.1d : rue
*/ 


var HollaBackSettings = {

	onLoad: function(settingsString) {
		// Setup object properties
		this.passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].createInstance(Components.interfaces.nsIPasswordManager);
		this.passwordManagerInternal = Components.classes["@mozilla.org/passwordmanager;1"].createInstance(Components.interfaces.nsIPasswordManagerInternal);
		this.prefService = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService);
		this.prefBranch = "hollaback.";
		this.prefBranchSettings = "settings.";
		this.Branch = this.prefService.getBranch(this.prefBranch);
		this.settingsBranch = this.prefService.getBranch(this.prefBranch+this.prefBranchSettings);
		this.enforcedSettings = "scheme"; // "scheme,host";
		this.defaultSettings = "skypeTo#!"; // was-> "path,uid,pwd*,c2cfrom,c2cto#"; // was-> "path,user,pass*,from,to#"
		this.defaultValues = {"scheme":"callto","host":"127.0.0.0","path":"voip?"}; // was-> "https, 127.0.0.1, serv?"
		this.settingsString = settingsString || (this.settingsBranch.prefHasUserValue("active") ? this.settingsBranch.getCharPref("active") : this.defaultSettings);
		var  settingsJoiner = (this.settingsString != "") ? "," : "";
		this.settingsArray = (this.enforcedSettings + settingsJoiner + this.settingsString).split(",");
		this.shouldPrefix  =  this.settingsBranch.prefHasUserValue("showtrans") && this.settingsBranch.getBoolPref("showtrans"); // default:false
		this.defaultPrefix = "1 US,44 Holland,36 Spain";
		this.prefixString  =  this.settingsBranch.prefHasUserValue("trans") ? this.settingsBranch.getCharPref("trans") : this.defaultPrefix;
		this.shouldStyle   = !this.settingsBranch.prefHasUserValue("showstyle") || this.settingsBranch.getBoolPref("showstyle"); // default:true
		var oldStyleRe = /vodial/;
		this.defaultStyle = "text-decoration: none; font-style: italic; background-image: url(chrome://hollaback/content/w.75.png); background-repeat: repeat; color: #1234AB; border-style: none; -moz-outline: #ABABFF dashed 1px !important";
		this.styleString = this.settingsBranch.prefHasUserValue("style") ? this.settingsBranch.getCharPref("style").replace(oldStyleRe,"hollaback") : this.defaultStyle;
		this.linkify     = this.settingsBranch.prefHasUserValue("linkify") && this.settingsBranch.getBoolPref("linkify"); // default:false
		this.activeArray = [];
		this.passManKey  = "HollaBack.ext";
		this.prefBox     = document.getElementById('prefbox');
		this.hiddenSpacerI = document.getElementById('hidden-spacer.i');
		//this.constructionbox = document.getElementById('designbox');
		this.designLabel = document.getElementById("label-design");
		this.designGroup = document.getElementById("group-design");
		this.designEntry = document.getElementById("active");
		this.transEnable = document.getElementById("showtrans");
		this.transEntry  = document.getElementById("trans");
		this.hiddenSpacerII = document.getElementById('hidden-spacer.ii');
		//this.styleLabel = document.getElementById("label-style");
		this.styleGroup  = document.getElementById("group-style");
		this.styleEnable = document.getElementById("showstyle");
		this.styleEntry  = document.getElementById("style");
		this.linkGroup   = document.getElementById("linkgroup");
		this.linkRadio   = document.getElementById("linkify");
		this.spanRadio   = document.getElementById("spanify");
		this.hollabackLabel = document.getElementById("parentBox").getAttribute("activelabel");
		this.helpLabel   = document.getElementById("help-button");
		
		while (this.prefBox.childNodes.length > 0) this.prefBox.removeChild(this.prefBox.childNodes[0]);
		
		this.reservedRe = /(?:([\#\*]{0,2})\!|\!([\#\*]{0,2}))()()$/;
		this.privateRe = /(?:([\#]?)\*|\*([\#]?))()()$/;
		this.calleeRe = /\#$/;
		this.passModifiedArray = [];
		for (var n in this.settingsArray) {
			var id = this.settingsArray[n],                              name = id;
			var isReserved = this.reservedRe.test(name); isReserved && ( name = name.replace(this.reservedRe,"$1$2"));
			var isPrivate = this.privateRe.test(name);   isPrivate  && ( name = name.replace(this.privateRe, "$1$2"));
			var isCallee = this.calleeRe.test(name);     isCallee   && ( name = name.replace(this.calleeRe,  ""));
			isPrivate && (isCallee=false); // we'll choose password-precedence
			this.activeArray.push(this.addEntryField(id, name, isReserved, isPrivate, isCallee));
			this.activeArray[this.activeArray.length-1].addEventListener("input", this.spaceCheck, true); }
		if (this.passModifiedArray.length > 0) {
			var length = this.passModifiedArray.length;
			var msgString = this.hollabackLabel+":\n\nThe password-field" + (length>1?"s '":" '") 
					+ this.passModifiedArray.join((length>2?"',":"'")+" and '")
					+ "' contained spaces. \nThe spaces were removed."; // this would only happen if mozilla implemented a way to alter passwords.
			alert(msgString); }
		this.activeArray.push(this.designEntry);
		this.activeArray.push(this.transEnable), this.activeArray.push(this.transEntry);
		this.activeArray.push(this.styleEnable);
		this.activeArray.push(this.styleEntry);
		this.activeArray.push(this.linkRadio);
			
		if (!this.loaded) {
			this.loaded = true;
			this.helpLabel.value = this.helpLabel.value + " " +String.fromCharCode(8801); // "&equiv;"
			this.designEntry.value = this.settingsString;
			this.transEnable.checked = this.shouldPrefix,  this.transEnable.doCommand();
			this.styleEnable.checked = this.shouldStyle,   this.styleEnable.doCommand();
			this.transEntry.value = this.prefixString;
			this.styleEntry.value = this.styleString;
			this.linkGroup.selectedIndex = this.linkify ? 0 : 1;
			this.designEntry.addEventListener('input', this.spaceCheck, true);
			//this.designEntry.addEventListener('keypress', this.designCommit, true);
			//window.addEventListener('mousemove', this.onMouseMove, true);
		}
		
		/*sizeToContent();*/
		if (settingsString) sizeToContent(); // <- not even necessary, really (construction-reload)
		else this.onMouseMove(null, true); // we'll just go ahead and show the hidden-prefs
	},
	
	addEntryField: function(id, name, isReserved, isPrivate, isCallee) {
		var newHbox = isCallee ? document.getElementById("template-entryrow-callee").cloneNode(true)
				: document.getElementById("template-entryrow-normal").cloneNode(true);
		var newDescription = newHbox.firstChild, newTextbox = newHbox.lastChild;
		newHbox.id = ""; newDescription.value = name+": "; newTextbox.id = id; 
		if (isPrivate) newTextbox.type = "password";
		if (!isCallee) {
			var value = isPrivate ? this.getPassword(name)
				: (this.settingsBranch.prefHasUserValue(name) ? this.settingsBranch.getCharPref(name) 
						: (this.defaultValues[name] ? this.defaultValues[name] : ""));
			if (isPrivate && this.spaceRe.test(value))
				this.passModifiedArray.push(name);
			newTextbox.value = value.replace(this.spaceRe, ""/*(isPrivate?"":"_")*/);
		}
		this.prefBox.appendChild(newHbox);
		return newTextbox;
	},
	
	getPassword: function(name) {
		var host= {value:""};
		var username= {value:""};
		var password= {value:""};
		try{ this.passwordManagerInternal.findPasswordEntry(this.passManKey,name,"",host,username,password); }
		catch(e) {}
		return password.value;
	},
	
	spaceRe: /\s/g,
	spaceCheck: function(evt) {
		var textbox = evt.target, matches = textbox.value.match(HollaBackSettings.spaceRe); 
		if (!matches) return;
		var isPrivate = (textbox.type == "password");
		var selectionStart = textbox.selectionStart, selectionEnd = textbox.selectionEnd;
		var decrement = matches.length; // the number of "global" matches
		textbox.value = textbox.value.replace(HollaBackSettings.spaceRe, ""/*(isPrivate?"":"_")*/);
		textbox.setSelectionRange(selectionStart-decrement, selectionEnd-decrement);
		if (isPrivate) { if (!textbox.spaceAlerted) { alert(HollaBackSettings.hollabackLabel+": \n\nSpaces aren't permitted in password-fields."); textbox.spaceAlerted = true;}}
	},
	
	// "OK" button was clicked
	onAccept: function() {
		return this.designCommit(null, true);
	},
	
	designCommit: function(evt, isClosing) {
		//var warningText = "You're about to change the parameter design   \n    -- values will revert to last-saved. Proceed?";
		var warningText = "You're about to change the parameter design   \n    -- current values will be saved. Proceed?";
		var isReturn = isClosing || (evt.keyCode + evt.charCode) == evt.DOM_VK_RETURN  || (evt.keyCode + evt.charCode) == evt.DOM_VK_ENTER;
		if (isReturn) {
			if (!isClosing) { evt.preventDefault(); evt.preventBubble(); evt.preventCapture(); evt.stopPropagation(); } // otherwise, our text-box return will close the dialog
			var fullParamString = this.enforcedSettings;
			var userParamString = this.designEntry.value;
			if (! /^\s*$/.test(userParamString)) fullParamString += ","+userParamString;
			// Duplicate-field Check
			var newParamArray = fullParamString.split(",").sort(); //var cloneArray = fullParamString.split(",");
			var principal, duplicateArray = [];
			while ((principal = newParamArray.shift())) 
				if (newParamArray.length > 0 && principal.replace(this.privateRe,"").replace(this.calleeRe,"") == newParamArray[0].replace(this.privateRe,"").replace(this.calleeRe,"")) 
					duplicateArray.push(principal);
			if (duplicateArray.length > 0) { 
				alert(this.hollabackLabel+": \n\nDuplicate Entries aren't allowed:\n"+duplicateArray.join(", "));
				this.onMouseMove(null, true); // show the hidden-prefs, in case they're not visible
				var selectionStart = this.designEntry.value.lastIndexOf(duplicateArray[0]);
				var selectionEnd = selectionStart + duplicateArray[0].length;
				if (this.designEntry.value.length-1 > selectionEnd) selectionEnd++;
				setTimeout("HollaBackSettings.designEntry.focus(); HollaBackSettings.designEntry.setSelectionRange("+selectionStart+", "+selectionEnd+");", 0); // "assist" the user by selection the relevant portion
				return false; }
			// "Did Anything Change?" Check
			if (userParamString == this.settingsString) { this.savePrefs(); return true; }
			// Change-commit Confirmation
			if (confirm(warningText)) {
				var settingsString = this.designEntry.value;
				this.savePrefs();
				this.onLoad(settingsString);
				return false;
			}
			else return false;
		}
	},
	
	// save all prefs other than "design"
	savePrefs: function() {
		for (var n in this.activeArray) 
		switch (this.activeArray[n].nodeName.toLowerCase()) {
			case "textbox":
					var value = this.activeArray[n].value;
					var id = this.activeArray[n].id,                             name = id;
					var isReserved = this.reservedRe.test(name); isReserved && ( name = name.replace(this.reservedRe,"$1$2"));
					var isPrivate = this.privateRe.test(name);   isPrivate  && ( name = name.replace(this.privateRe, "$1$2"));
					var isCallee = this.calleeRe.test(name);     isCallee   && ( name = name.replace(this.calleeRe,  ""));
					isPrivate && (isCallee=false); // we'll choose password-precedence
					if (isPrivate) {
						try{ this.passwordManager.removeUser(this.passManKey,name); }
						catch(e) {}
						this.passwordManager.addUser(this.passManKey,name,value); 
					}
					else if (!isCallee) this.settingsBranch.setCharPref(name, value);
					break;
			case "checkbox":
					var checked = this.activeArray[n].checked;
					name = this.activeArray[n].id;
					this.settingsBranch.setBoolPref(name, checked);
					break;
			case "radio":
					var selected = this.activeArray[n].selected;
					name = this.activeArray[n].id;
					this.settingsBranch.setBoolPref(name, selected);
					break;
		}
					
		
		this.prefService.savePrefFile(null); // save the prefs to disk
	},
	
	// mouse-move detected - handle hidden-prefs
	onMouseMove: function(evt, override) {
		if(override || evt.shiftKey) {
			HollaBackSettings.hiddenSpacerI.hidden = false;
			HollaBackSettings.designLabel.hidden = false;
			HollaBackSettings.designGroup.hidden = false;
			HollaBackSettings.hiddenSpacerII.hidden = false;
			//HollaBackSettings.styleLabel.hidden = false;
			HollaBackSettings.styleGroup.hidden = false;
			sizeToContent(); }
	}
};